---
layout: markdown_page
title: "Team Retrospectives"
---

## Requirements for an efficient retrospective

In order to generate the best results from a retrospective, the following
elements must be present:

1. A safe environment for feedback and discussion
1. A plan for advancing discussion from facts to conclusions

Not every retrospective will require both of these elements - for example,
an iteration where "nothing went wrong" may see retrospectives that don't
benefit from a safe environment. Similarly, an iteration that has nothing but
"obvious" problems will probably have a productive retrospective even without a
strong plan for the discussion. However, even iterations that seem fine on the
surface can harbor deep problems, so it is always best to be prepared.

## On this page
{:.no_toc}

- TOC
{:toc}

## Establishing a safe environment

Retrospectives are inherently conversations about _what went well_ and _what
went wrong_ in a project or iteration. While it's easy to talk about _what went
well_, _what went wrong_ can be a touchy subject. Without a safe environment,
issues may go unmentioned and the team won't improve as rapidly as they
otherwise could. In order to collect as much feedback as possible, we recommend
that you observe the following:

1. **All retrospectives should have an impartial moderator.** This moderator
   actively attempts to remain objective and is focused on guiding the
   conversation forward throughout the meeting. If participants feel that the
   moderator has a stake in the conversation, they may feel as though it is not
   safe to voice dissent or share concerns. Normally the manager should act as
   this moderator - however, in some circumstances the manager may feel a strong
   need or desire to participate in the conversation. In that case they should
   find a peer, Director, or other member of the team willing to moderate.
1. **Emotions are not only _allowed_ in retrospectives, they should be encouraged.**
   Emotional language ("I was angry when...," "It made me sad that...") not only
   helps convey intensity, it also helps expose issues that may have been
   difficult to sort out otherwise. Make sure all participants know they are
   free to express their feelings, although we do expect them to stay consistent
   with our [values](/handbook/values).
1. **When possible, all parties should be present.** No one should have to worry
   about sharing concerns or experiences because another party isn't there to
   represent their side of the story.
1. **When necessary, get people face to face.** After a particularly difficult
   iteration, or when there's a strong risk that emotions will be running high,
   it's almost always worth the cost to have everyone in a video meeting to talk
   through the retrospective in real-time.

## Having a plan

It's easy for retrospectives to go off the rails if there isn't a good plan for
collecting actionable insights. If the moderator doesn't guide the conversation
successfully, the retrospective could be dominated by a few "loud voices" or
could stay focused on the facts and feelings about the past iteration without
drawing any conclusions. To make sure the conversation is productive, we
recommend that you **have a clear agenda for the conversation.** The moderator
for the retrospective is then responsible for ensuring the agenda is followed
and completed. While the specific nature of this agenda will vary from team to
team, we recommend something that follows this general pattern:

1. **Introduction** - remind people of the purpose of the retrospective, and
   that the conversation should be scoped to the project/iteration under
   review. Ensure everyone understands the rest of the agenda.
1. **Gather data** - don't try to draw any conclusions up front, simply
   collect facts. This can be done by constructing a timeline, soliciting
   impressions ("what made you mad, sad, or glad in this iteration?," etc.), or
   any other number of fact collecting exercises.
1. **Generate insights** - now that you have all of the facts, try to work
   together to identify patterns or causal relationships (because we did
   _x_, _y_ happened).
1. **Decide what to do** - with the insights firmly in hand, it should be
   fairly easy to identify action items for the team. This could be things
   to change with our process, it could be things to experiment with in the
   next iteration, or any other number of things.
1. **Close the retrospective** - make sure everyone who participated receives
   positive feedback about how they helped create these results. Observe any
   surprising or unexpected results from the retrospective, which confirms that
   the retrospective was valuable. Make sure all of the action items are
   appropriately assigned to one or more team members with clear expectations
   for when they should be completed.

## Learn More

We recommend the following resources if you'd like to learn more about running
effective retrospectives:

1. [Agile Retrospectives: Making Good Teams Great](https://www.amazon.com/Agile-Retrospectives-Making-Teams-Great/dp/0977616649)
1. [The Human Side of Post Mortems](https://www.oreilly.com/webops-perf/free/the-human-side-of-postmortems.csp)
